from osv import osv, fields
from tools.translate import _
import os
import base64, urllib
import netsvc

from datetime import datetime, timedelta,date
from dateutil.relativedelta import relativedelta
import time
import cStringIO
from xlwt import Workbook, XFStyle, Borders, Pattern, Font, Alignment,  easyxf
from PIL import Image
import addons

class Report(osv.osv_memory):
    
     """   For Printing Excel Reports   """
     
     _name = "event.report"
    
    
     def report_get(self,cr,uid,ids,context=None):
  
        this=self.browse(cr,uid,ids)
        
        #Define the font attributes for header
        fnt = Font()
        fnt.name = 'Arial'
        fnt.height= 275
        
        #Define the font attributes for header
        content_fnt = Font()
        content_fnt.name ='Arial'
        content_fnt.height =220
        align_content = Alignment()
        align_content.horz= Alignment.HORZ_CENTER
     
        borders = Borders()
        borders.left = 0x02
        borders.right = 0x02
        borders.top = 0x02
        borders.bottom = 0x02
        
        #The text should be centrally aligned
        align = Alignment()
        align.horz = Alignment.HORZ_CENTER
        align.vert = Alignment.VERT_CENTER
        
        #We set the backgroundcolour here
        pattern = Pattern()
        pattern.pattern = Pattern.SOLID_PATTERN
        pattern.pattern_fore_colour =  0x1F

        #apply the above settings to the row(0) header
        style_header= XFStyle()
        style_header.font= fnt
        style_header.pattern= pattern
        style_header.borders = borders
        style_header.alignment=align    
        
        
        style_content= XFStyle()
        style_content.alignment = align_content 
        style_content.font = content_fnt

        wb = Workbook()
        ws = wb.add_sheet('Information')
        ws.row(0).height=1000
        ws.write(0,0,'Project Name',style_header)
        ws.col(0).width = 10000
        ws.write(0,1,'Total',style_header)
        ws.col(1).width = 4400
        ws.write(0,2,'Reception date',style_header)
        ws.col(2).width = 5000
        ws.write(0,3,'Sent date',style_header)
        ws.col(3).width = 4400
        ws.write(0,4,'Last recall',style_header)
        ws.col(4).width = 4400
        ws.write(0,5,'Next recall',style_header)
        ws.col(5).width = 4400
        ws.write(0,6,'Win/Lost',style_header)
        ws.col(6).width = 4400
        ws.write(0,7,'Quote validated',style_header)
        ws.col(7).width = 5000
        ws.write(0,8,'Margin',style_header)
        ws.col(8).width = 4400
        ws.write(0,9,'Total time spent on project',style_header)
        ws.col(9).width = 10000

       
        for each in this:
          
               cr.execute("select quote.name, quote.amount_total, quote.recp_date, quote.quot_date, quote.last_recall,\
                quote.next_recall, winlost.name,quote.total_time,quote.amount_untaxed,quote.total_buy from event_quotation quote left join event_winlost as winlost on (quote.win_lost=winlost.id)"),
               
               i=0
#               print "DATABASE",cr.fetchall()
               for row in cr.fetchall():
                   i+=1
                   ws.write(i,0,row[0])
                   ws.write(i,1,row[1])
                   ws.write(i,2,date(int(row[2][:4]),int(row[2][5:7]),int(row[2][8:])),easyxf('alignment:horizontal center;',num_format_str='DD/MM/YY'))

                   if row[3]:   
                       ws.write(i,3,date(int(row[3][:4]),int(row[3][5:7]),int(row[3][8:])),easyxf('alignment:horizontal center;',num_format_str='DD/MM/YY'))
                   else:ws.write(i,3,'')    
                   if row[4]:
                       ws.write(i,4,date(int(row[4][:4]),int(row[4][5:7]),int(row[4][8:])),easyxf('alignment:horizontal center;',num_format_str='DD/MM/YY'))
                   else:ws.write(i,4,'')    
                   if row[5]:    
                       ws.write(i,5,date(int(row[5][:4]),int(row[5][5:7]),int(row[5][8:])),easyxf('alignment:horizontal center;',num_format_str='DD/MM/YY'))
                   else:ws.write(i,5,'')
                 
                   
                 
                   margin=((row[8]-row[9])/(row[9]))
                   
                       
                   ws.write(i,6,row[6],style_content)
                   ws.write(i,7,row[6] and (row[1]) or 0)
                   ws.write(i,8,margin,style_content)
                   ws.write(i,9,row[7],style_content)
               
               f = cStringIO.StringIO()
               wb.save(f)
               out=base64.encodestring(f.getvalue())
               
               
               
        return self.write(cr, uid, ids, {'data':out, 'name':'export.xls'}, context=context)
       
    
     _columns = {
                    'name':fields.char('Filename',size=128),
                    'data':fields.binary('Data'),
                }

Report()    


class CommercialReport(osv.osv_memory):
    
     """   For Printing Excel Reports   """
     
     _name = "commercial.information"
    
    
   
     _columns = {
                    'name':fields.char('Filename',size=128),
                    'data':fields.binary('Data'),
                }


    
     def report_get(self,cr,uid,ids,context=None):
  
        this=self.browse(cr,uid,ids)
        
        #Define the font attributes for header
        fnt = Font()
        fnt.name = 'Arial'
        fnt.height= 275
        
        #Define the font attributes for header
        content_fnt = Font()
        content_fnt.name ='Arial'
        content_fnt.height =220
        align_content = Alignment()
        align_content.horz= Alignment.HORZ_CENTER
     
        borders = Borders()
        borders.left = 0x02
        borders.right = 0x02
        borders.top = 0x02
        borders.bottom = 0x02
        
        #The text should be centrally aligned
        align = Alignment()
        align.horz = Alignment.HORZ_CENTER
        align.vert = Alignment.VERT_CENTER
        
        #We set the backgroundcolour here
        pattern = Pattern()
        pattern.pattern = Pattern.SOLID_PATTERN
        pattern.pattern_fore_colour =  0x1F

        #apply the above settings to the row(0) header
        style_header= XFStyle()
        style_header.font= fnt
        style_header.pattern= pattern
        style_header.borders = borders
        style_header.alignment=align    
        
        
        style_content= XFStyle()
        style_content.alignment = align_content 
        style_content.font = content_fnt


        wb = Workbook()
        ws = wb.add_sheet('Commercial')
        ws.row(0).height=1000
        ws.write(0,0,'Company name',style_header)
        ws.col(0).width = 10000
        ws.write(0,1,'Contact name',style_header)
        ws.col(1).width = 7000
        ws.write(0,2,'Job of the contact',style_header)
        ws.col(2).width = 7000
        ws.write(0,3,'Email of the contact',style_header)
        ws.col(3).width = 7000
        ws.write(0,4,'Site web of the company',style_header)
        ws.col(4).width = 8000
        ws.write(0,5,'Phone no. of the contact',style_header)
        ws.col(5).width = 8000
        ws.write(0,6,'Fax number of the contact',style_header)
        ws.col(6).width = 8000
        ws.write(0,7,'Cell ph. no. of the contact',style_header)
        ws.col(7).width = 8000
        ws.write(0,8,'Company adress',style_header)
        ws.col(8).width = 8000
        ws.write(0,9,'Postal code',style_header)
        ws.col(9).width = 10000
        ws.write(0,10,'City',style_header)
        ws.col(10).width = 10000
        ws.write(0,11,'Country of the company',style_header)
        ws.col(11).width = 10000
        ws.write(0,12,'Contact source',style_header)
        ws.col(12).width = 10000
        ws.write(0,13,'Activity of the company',style_header)
        ws.col(13).width = 10000
        ws.write(0,14,'To visit (Y/N)',style_header)
        ws.col(14).width = 5000
        ws.write(0,15,'Notes',style_header)
        ws.col(15).width = 10000
        

       
        for each in this:
          
               cr.execute("""select company.name,companyadd.name,companyadd.function,companyadd.email,companyadd.website,companyadd.phone,companyadd.fax,companyadd.mobile, ARRAY_TO_STRING(ARRAY[companyadd.street,companyadd.street2,state.name ], ',') , companyadd.zip,companyadd.city,country.name,contact.name,activity.name,tovisit.name, company.comment, 
               DATE_PART( 'QUARTER',event.end_date) AS Quarter,to_char(event.end_date,'YYYY')
from event_quotation as event left join res_partner as company on(event.cust_id=company.id) left join res_partner_address as companyadd on (company.id=companyadd.partner_id) left join res_country as country on (companyadd.country_id=country.id) left join event_contact as contact
on (company.contact_user=contact.id) left join event_tovisit as tovisit on (company.tovisit=tovisit.id) left join res_country_state as state on (companyadd.state_id=state.id)
left join event_activity as activity on (company.activity=activity.id) order by QUARTER"""),
               
               i=0
               flag1=flag2=flag3=flag4=False
#               print "DATABASE",cr.fetchall()
               for row in cr.fetchall():
               
                   if row[16]:
                       
                      if row[16]==1 and not flag1:
                           i+=1
                           ws.row(i).height=500
                           ws.write(i,0,'1st Trimester-'+row[17],easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;')) 
                           flag1=True
                            
                      if row[16]==2 and not flag2:
                           i+=1
                           ws.row(i).height=500
                           ws.write(i,0,'2nd Trimester-'+row[17],easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;')) 
                           flag2=True
                           
                      if row[16]==3 and not flag3:
                           i+=1
                           ws.row(i).height=500 
                           ws.write(i,0,'3rd Trimester-'+row[17],easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;')) 
                           flag3=True
                           
                      if row[16]==4 and not flag4:
                           i+=1
                           ws.row(i).height=500 
                           ws.write(i,0,'4th Trimester-'+row[17],easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;')) 
                           flag4=True               
                   
                   i+=1
                   ws.write(i,0,row[0])
                   ws.write(i,1,row[1])
                   ws.write(i,2,row[2])
                   ws.write(i,3,row[3])
                   ws.write(i,4,row[4])
                   ws.write(i,5,row[5])
                   ws.write(i,6,row[6])
                   ws.write(i,7,row[7])
                   ws.write(i,8,row[8])
                   ws.write(i,9,row[9])
                   ws.write(i,10,row[10])
                   ws.write(i,11,row[11])
                   ws.write(i,12,row[12])
                   ws.write(i,13,row[13])
                   ws.write(i,14,row[14])
                   ws.write(i,15,row[15])
               
               f = cStringIO.StringIO()
               wb.save(f)
               out=base64.encodestring(f.getvalue())
               
               
               
        return self.write(cr, uid, ids, {'data':out, 'name':'export.xls'}, context=context)
       
    
CommercialReport()    



class ReportFinance(osv.osv_memory):
    
     """   For Printing Excel Reports   """
     
     _name = "finance.information"
    
    
     def report_get(self,cr,uid,ids,context=None):
  
        this=self.browse(cr,uid,ids)
        
        #Define the font attributes for header
        fnt = Font()
        fnt.name = 'Arial'
        fnt.height= 275
        
        #Define the font attributes for header
        content_fnt = Font()
        content_fnt.name ='Arial'
        content_fnt.height =220
        align_content = Alignment()
        align_content.horz= Alignment.HORZ_CENTER
     
        borders = Borders()
        borders.left = 0x02
        borders.right = 0x02
        borders.top = 0x02
        borders.bottom = 0x02
        
        #The text should be centrally aligned
        align = Alignment()
        align.horz = Alignment.HORZ_CENTER
        align.vert = Alignment.VERT_CENTER
        
        #We set the backgroundcolour here
        pattern = Pattern()
        pattern.pattern = Pattern.SOLID_PATTERN
        pattern.pattern_fore_colour =  0x1F

        #apply the above settings to the row(0) header
        style_header= XFStyle()
        style_header.font= fnt
        style_header.pattern= pattern
        style_header.borders = borders
        style_header.alignment=align    
        
        
        style_content= XFStyle()
        style_content.alignment = align_content 
        style_content.font = content_fnt

        wb = Workbook()
        ws = wb.add_sheet('Finance Information')
        ws.row(0).height=800
        ws.write(0,0,'Invoice No',style_header)
        ws.col(0).width = 10000 
        ws.col(9).width = 7000
     
        ws.write(0,1,'Quote No',style_header)
        ws.col(1).width = 10000
        ws.write(0,2,'Status',style_header)
        ws.col(2).width = 4400
        ws.write(0,3,'Responsible',style_header)
        ws.col(3).width = 6000
        ws.write(0,4,'Name of the company',style_header)
        ws.col(4).width = 7000
        ws.write(0,5,'Reference group',style_header)
        ws.col(5).width = 6000
        ws.write(0,6,'Contact name',style_header)
        ws.col(6).width = 6000
        ws.write(0,7,'Country',style_header)
        ws.col(7).width = 7000
        ws.write(0,8,'Contract No',style_header)
        ws.col(8).width = 7000
        ws.write(0,9,'Buying price HT',style_header)
        ws.col(9).width = 7000
        ws.write(0,10,'VAT',style_header)
        ws.col(10).width = 7000
        ws.write(0,11,'Selling price HT',style_header)
        ws.col(11).width = 7000
        ws.write(0,12,'Selling price with VAT',style_header)
        ws.col(11).width = 7000
        ws.write(0,13,'Margin HT',style_header)
        ws.col(12).width = 7000
        ws.write(0,14,'Total VAT',style_header)
        ws.col(13).width = 7000


       
        for each in this:
          
               cr.execute("""select event.invoice,event.name,event.state,users.name,company.name,company.grp_name,companyadd.name,country.name,event.total_buy,event.amount_untaxed,event.amount_total,event.amount_tax,event.amount_untaxed,event.total_buy 
                             from event_quotation as event left join res_users as users on (event.user_id=users.id) left join res_partner as company on (event.cust_id=company.id) 
                             left join res_partner_address as companyadd on (company.id=companyadd.partner_id) left join res_country as country on (companyadd.country_id=country.id) """),
               
               i=0
#               print "DATABASE",cr.fetchall()
               for row in cr.fetchall():
                   i+=1
                   margin=((row[12]-row[13])/(row[13]))
                   ws.write(i,0,row[0])
                   ws.write(i,1,row[1])
                   ws.write(i,2,row[2])
                   ws.write(i,3,row[3])
                   ws.write(i,4,row[4])
                   ws.write(i,5,row[5])
                   ws.write(i,6,row[6])
                   ws.write(i,7,row[7])
                   ws.write(i,8,'')
                   ws.write(i,9,row[8])
                   ws.write(i,10,'VAT')
                   ws.write(i,11,row[9])
                   ws.write(i,12,row[10])
                   ws.write(i,13,margin)
                   ws.write(i,14,row[11])
               
               f = cStringIO.StringIO()
               wb.save(f)
               out=base64.encodestring(f.getvalue())
               
               
               
        return self.write(cr, uid, ids, {'data':out, 'name':'export.xls'}, context=context)
       
    
     _columns = {
                    'name':fields.char('Filename',size=128),
                    'data':fields.binary('Data'),
                }

ReportFinance()    


class ReportProject(osv.osv_memory):
    
     """   For Printing Excel Reports   """
     
     _name = "project.information"
    
    
     def report_get(self,cr,uid,ids,context=None):
  
        this=self.browse(cr,uid,ids)
        
        #Define the font attributes for header
        fnt = Font()
        fnt.name = 'Arial'
        fnt.height= 275
        
        #Define the font attributes for header
        content_fnt = Font()
        content_fnt.name ='Arial'
        content_fnt.height =220
        align_content = Alignment()
        align_content.horz= Alignment.HORZ_CENTER
     
        borders = Borders()
        borders.left = 0x02
        borders.right = 0x02
        borders.top = 0x02
        borders.bottom = 0x02
        
        #The text should be centrally aligned
        align = Alignment()
        align.horz = Alignment.HORZ_CENTER
        align.vert = Alignment.VERT_CENTER
        
        #We set the backgroundcolour here
        pattern = Pattern()
        pattern.pattern = Pattern.SOLID_PATTERN
        pattern.pattern_fore_colour =  0x1F

        #apply the above settings to the row(0) header
        style_header= XFStyle()
        style_header.font= fnt
        style_header.pattern= pattern
        style_header.borders = borders
        style_header.alignment=align    
        
        #apply the style for rest of the content
        style_content= XFStyle()
        style_content.alignment = align_content 
        style_content.font = content_fnt

 
        wb = Workbook()
        ws = wb.add_sheet('Finance Information')
        ws.row(0).height=1000
        ws.write(0,0,'Quote No',style_header)
        ws.col(0).width = 10000
        ws.write(0,1,'Responsible',style_header)
        ws.col(1).width = 10000
        ws.write(0,2,'Month',style_header)
        ws.col(2).width = 4400
        ws.write(0,3,'Start date',style_header)
        ws.col(3).width = 5000
        ws.write(0,4,'End date',style_header)
        ws.col(4).width = 5000
        ws.write(0,5,'Reference group',style_header)
        ws.col(5).width = 6000
        ws.write(0,6,'Destination city',style_header)
        ws.col(6).width = 6000
        ws.write(0,7,'Participants',style_header)
        ws.col(7).width = 7000
        ws.write(0,8,'Kind of operation',style_header)
        ws.col(8).width = 7000
       
       
        for each in this:
               cr.execute("""SELECT event.name,userid.name,to_char(event.end_date,'Month-YY'),to_char(event.start_date,'dd/mm/yy'),
               to_char(event.end_date,'dd/mm/yy'),partner.grp_name,city.name,event.participant as "PAR",operation.name,
               DATE_PART( 'QUARTER',event.end_date) AS Quarter from event_quotation as event left join res_users as userid on (event.user_id=userid.id) 
               left join res_partner as partner on (event.cust_id=partner.id) left join event_city as city on (event.city_id=city.id) 
               left join event_operation as operation on (event.operation_id=operation.id) order by Quarter;"""),
               
               i=0
               flag1=flag2=flag3=flag4=False
#               print "DATABASE",cr.fetchall()
               for row in cr.fetchall():
                      
                   if row[9]:
                       
                      if row[9]==1 and not flag1:
                           i+=1
                           ws.row(i).height=500
                           ws.write(i,0,'1st Trimester-'+row[4].split('/')[2],easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;')) 
                           flag1=True
                            
                      if row[9]==2 and not flag2:
                           i+=1
                           ws.row(i).height=500
                           ws.write(i,0,'2nd Trimester-'+row[4].split('/')[2],easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;')) 
                           flag2=True
                           
                      if row[9]==3 and not flag3:
                           i+=1
                           ws.row(i).height=500 
                           ws.write(i,0,'3rd Trimester-'+row[4].split('/')[2],easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;')) 
                           flag3=True
                           
                      if row[9]==4 and not flag4:
                           i+=1
                           ws.row(i).height=500 
                           ws.write(i,0,'4th Trimester-'+row[4].split('/')[2],easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;')) 
                           flag4=True               
                   
                   i+=1
                   ws.write(i,0,row[0])
                   ws.write(i,1,row[1])
                   ws.write(i,2,row[2])
                   ws.write(i,3,row[3])
                   ws.write(i,4,row[4])
                   ws.write(i,5,row[5])
                   ws.write(i,6,row[6])
                   ws.write(i,7,row[7])
                   ws.write(i,8,row[8])

               f = cStringIO.StringIO()
               wb.save(f)
               out=base64.encodestring(f.getvalue())
               
               
               
        return self.write(cr, uid, ids, {'data':out, 'name':'export.xls'}, context=context)
       
    
     _columns = {
                    'name':fields.char('Filename',size=128),
                    'data':fields.binary('Data'),
                }
    
    
ReportProject()    

class ReportEvent(osv.osv_memory):
    
     """   For Printing Excel Reports   """
     
     _name = "myreport.myreport"
    
    
     def report_get(self,cr,uid,ids,context=None):
  
        this=self.browse(cr,uid,ids)
      
        #Define the font attributes for header
        fnt = Font()
        fnt.name = 'Arial'
        fnt.height= 275
        
        #Define the font attributes for header
        content_fnt = Font()
        content_fnt.name ='Arial'
        content_fnt.height =220
        align_content = Alignment()
        align_content.horz= Alignment.HORZ_CENTER
     
        borders = Borders()
        borders.left = 0x02
        borders.right = 0x02
        borders.top = 0x02
        borders.bottom = 0x02
        
        #The text should be centrally aligned
        align = Alignment()
        align.horz = Alignment.HORZ_CENTER
        align.vert = Alignment.VERT_CENTER
        
        #We set the backgroundcolour here
        pattern = Pattern()
        pattern.pattern = Pattern.SOLID_PATTERN
        pattern.pattern_fore_colour =  0x1F

        #apply the above settings to the row(0) header
        style_header= XFStyle()
        style_header.font= fnt
        style_header.pattern= pattern
        style_header.borders = borders
        style_header.alignment=align    
        
        
        style_content= XFStyle()
        style_content.alignment = align_content 
        style_content.font = content_fnt

        wb = Workbook()
        ws = wb.add_sheet('Information')
        ws.row(9).height=1000
        ws.write(9,0,'Timing',style_header)
        ws.col(0).width = 8000
        ws.write(9,1,'Day by Day Services',style_header)
        ws.col(1).width = 10000
        ws.write(9,2,'Units',style_header)
        ws.col(2).width = 4000
        ws.write(9,3,'Comments',style_header)
        ws.col(3).width = 12000
        ws.write(9,4,'Supplier Contact',style_header)
        ws.col(4).width = 8000
       
       
        for each in this:
             
               ws.write(0,0,each.quote_id.name or '')
               ws.write(1,0,each.quote_id.start_date or '')
               ws.write(3,1,each.quote_id.cust_id and each.quote_id.cust_id.name or '')
               ws.write(4,1,each.quote_id.cust_id and each.quote_id.cust_id.grp_name or '')
               ws.write(5,1,each.quote_id.cust_id and each.quote_id.cust_id.address and each.quote_id.cust_id.address[0].name or '')
              
               i=10    
               order_days=[]
               for order in each.quote_id.order_line:
                   if order.day not in order_days:
                       order_days.append(order.day)   
                     
                       ws.write(i,1, time.strftime('%A,%d %B,%Y', time.strptime(order.day,'%Y-%m-%d')),easyxf('alignment:horizontal center, vertical center;'
                                                                                     'font: name Arial,height 250, bold True;'
                                                                                     'pattern: pattern solid, fore_colour lime;'))  
                       i+=1
                   for each in order.service_ids:
                           
                      
                       ws.write(i,1,each.service_id.name or '')
                       ws.write(i,2,each.quantity or '')
                    
                       supplier_name=(each.partner_id.address or '') and each.partner_id.address[0].name or ''
                       supplier_street=(each.partner_id.address or '') and each.partner_id.address[0].street and ('-'+each.partner_id.address[0].street) or ''
                       supplier_city=(each.partner_id.address or '') and each.partner_id.address[0].city and ('-'+each.partner_id.address[0].city) or ''
                       supplier_country=(each.partner_id.address or '') and (each.partner_id.address[0].country_id and '-'+each.partner_id.address[0].country_id.name or '')
                       supplier_phone=(each.partner_id.address or '') and ('-Tel:'+(each.partner_id.address[0].phone or '') or '')
                    
                       ws.write(i,4,supplier_name+supplier_street+supplier_city+supplier_country+supplier_phone)
                       i+=1

               user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
               if user.company_id:
                  
                   addon_path=addons.get_module_path('french_event')
                   ws.insert_bitmap(os.path.join(addon_path,'images','logo.bmp'),3,4)
#                   ws.write(i+6,3,user.company_id.name or '')
                   
                   company_street=(user.company_id.partner_id.address[0].street or '')+(user.company_id.partner_id.address[0].street2 or '')
#                   company_zip=user.company_id.partner_id.address[0].zip
                
                   company_city=user.company_id.partner_id.address[0].city
                   company_phone=user.company_id.partner_id.address[0].phone
                   company_address=company_street+company_city
                   company2_address=''
                   if len(user.company_id.partner_id.address)>1:
                       company2_street=(user.company_id.partner_id.address[1].street or '')+(user.company_id.partner_id.address[1].street2 or '')
                    
    #                   company2_zip=user.company_id.partner_id.address[1].zip
                       company2_city=user.company_id.partner_id.address[1].city
                       company2_address=company2_street+company2_city
                       company2_phone=user.company_id.partner_id.address[1].phone
                       
#                   ws.write(i+7,2,'Head Office :'+(company_address or ''))
#                   ws.write(i+7,3,'-Operational Office :'+(company2_address or ''))
#                   ws.write(i+8,2,'Tel : '+(company_phone or ''))
#                   ws.write(i+8,3,'-Fax : '+(user.company_id.partner_id.address[0].fax or ''))
#                   ws.write(i+9,2,user.company_id.partner_id.address[0].website or '')
               
               f = cStringIO.StringIO()
               wb.save(f)
               out=base64.encodestring(f.getvalue())
               
               
               
        return self.write(cr, uid, ids, {'data':out, 'name':'export.xls'}, context=context)
       
    
     _columns = {
                    'name':fields.char('Filename',size=128),
                    'data':fields.binary('Data'),
                    'quote_id':fields.many2one('event.quotation','Quotation',required=True),
                }

ReportEvent()    
















